Summary: The Perl programming language.
Name: perl
Version: 5.8.3
Release: 5tr
License: GPL
Group: Trustix Official
Url: http://www.perl.com
Source0: ftp://ftp.perl.org/pub/CPAN/src/perl-%{version}.tar.gz
Source1: perl-headers-wanted
Source2: perl-5.8.0-h2ph-ansi_header.patch
Patch1: perl-5.8.0-makemaker-ld_run_path.patch
Patch3: perl-5.8.2-root.patch
Patch4: perl-5.8.3-desthtml.patch
Patch5: perl-5.8.3-openwall-1.3-tempfile.patch.gz
Patch6: perl-5.8.3-CAN-2005-0155-0156.patch
Buildroot: /var/tmp/%{name}-root
Requires: gdbm
Requires: db4
BuildRequires: gdbm-devel
BuildRequires: db4-devel
# Removed untill prove of need: (christht)
#%define _noVersionedDependencies 1
Provides: perl <= %{version}
%define threading 1

%if %threading
%define thread_arch -thread-multi
%else
%define thread_arch %{nil}
%endif

%define full_arch %{_arch}-%{_os}%{thread_arch}
%define perl_root %{_libdir}/perl5



%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications (and what it excels
at) are probably system administration utilities and web programming.
A large proportion of the CGI scripts on the web are written in Perl.
You need the perl package installed on your system so that your
system can handle Perl scripts.


%package devel
Version: %{version}
Summary: The Perl programming language (devel).
Group: Trustix Official
Requires: %{name} = %{version}-%{release}

%description devel
This is the devel package for %{name}.


%package doc
Version: %{version}
Summary: The Perl programming language (documentation).
Group: Trustix Official
Requires: %{name} = %{version}-%{release}

%description doc
This is the documentation package for %{name}.


%prep
%setup -q -n perl-%{version}
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

find . -name \*.orig -exec rm -fv {} \;


%build
rm -f config.sh Policy.sh
sh Configure -des \
    -Darchname=%{_arch}-%{_os} \
    -Dcc='%{__cc}' \
    -Dcf_by=Trustix \
    -Dd_dosuid \
    -Dd_semctl_semun \
    -Di_db \
    -Di_gdbm \
    -Dmyhostname=localhost \
    -Doptimize="$RPM_OPT_FLAGS" \
    -Dperladmin=root@localhost \
    -Dprefix=%{_prefix} \
    -Dsiteprefix=%{_prefix} \
    -Duselargefiles \
    -Dvendorprefix=%{_prefix} \
    -Dman3dir=%{_mandir}/man3 \
    -Dman1dir=%{_mandir}/man1 \
%if %threading
    -Dusethreads \
%endif


# create lib/Config.pm
#make lib/Config.pm

make

# Strip binaries (done now rather than at install)
strip perl
strip suidperl
strip x2p/a2p

# Yes.  But not today
# make test


%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install install-all extras.install install.perl install.man

install -m 755 utils/pl2pm ${RPM_BUILD_ROOT}%{_prefix}/bin/pl2pm

cp -f utils/h2ph utils/h2ph_patched
bzcat %{SOURCE2} | patch -p1

install -d -m 755 $RPM_BUILD_ROOT%{perl_root}/%{version}/%{full_arch}
install -d -m 755 $RPM_BUILD_ROOT%{perl_root}/site_perl/%{version}/i586-linux

# This fails on sys/_types.h.  Ignore for now.
LD_LIBRARY_PATH=. ./perl -Ilib utils/h2ph_patched -a -d $RPM_BUILD_ROOT%{perl_root}/%{version}/%{full_arch} `cat %{SOURCE1}` > /dev/null || :

(
    # i don't like hardlinks, having symlinks instead:
    cd $RPM_BUILD_ROOT%{_bindir}
    ln -sf perl5 perl
    ln -s perl%{version} perl5
)



(cd $RPM_BUILD_ROOT%{_mandir}/man3/
	mv threads.3 perlthreads.3)


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%files 
%defattr(-,root,root)
%doc README
%{_bindir}/a2p
%{_bindir}/cpan
%{_bindir}/enc2xs
%{_bindir}/find2perl
%{_bindir}/libnetcfg
%{_bindir}/instmodsh
%{_bindir}/perl
%{_bindir}/perl%{version}
%{_bindir}/perl5
%{_bindir}/perlbug
%{_bindir}/perlivp
%{_bindir}/piconv
%{_bindir}/pod2html
%{_bindir}/pod2latex
%{_bindir}/pod2man
%{_bindir}/pod2text
%{_bindir}/pod2usage
%{_bindir}/prove
%{_bindir}/psed
%{_bindir}/s2p
%{_bindir}/splain
%{_bindir}/xsubpp
%attr(4711,root,root) %{_bindir}/sperl%{version}
%attr(4711,root,root) %{_bindir}/suidperl
%dir %{perl_root}
%dir %{perl_root}/%{version}
     %{perl_root}/%{version}/%{full_arch}
     %{perl_root}/%{version}/*.pl
     %{perl_root}/%{version}/*.pm
%dir %{perl_root}/%{version}/Attribute
     %{perl_root}/%{version}/Attribute/Handlers.pm
     %{perl_root}/%{version}/B
%dir %{perl_root}/%{version}/CGI
     %{perl_root}/%{version}/CGI/*.pm
     %{perl_root}/%{version}/CPAN
     %{perl_root}/%{version}/Carp
     %{perl_root}/%{version}/Class
     %{perl_root}/%{version}/Devel
     %{perl_root}/%{version}/Digest
%dir %{perl_root}/%{version}/Encode
     %{perl_root}/%{version}/Encode/CN
     %{perl_root}/%{version}/Encode/ConfigLocal_PM.e2x
     %{perl_root}/%{version}/Encode/JP
     %{perl_root}/%{version}/Encode/KR
     %{perl_root}/%{version}/Encode/MIME
     %{perl_root}/%{version}/Encode/Makefile_PL.e2x
     %{perl_root}/%{version}/Encode/Unicode
     %{perl_root}/%{version}/Encode/_PM.e2x
     %{perl_root}/%{version}/Encode/_T.e2x
     %{perl_root}/%{version}/Exporter
%dir %{perl_root}/%{version}/ExtUtils
     %{perl_root}/%{version}/ExtUtils/*.pm
     %{perl_root}/%{version}/ExtUtils/Command
     %{perl_root}/%{version}/ExtUtils/Liblist
     %{perl_root}/%{version}/ExtUtils/MANIFEST.SKIP
%dir %{perl_root}/%{version}/ExtUtils/MakeMaker
     %{perl_root}/%{version}/ExtUtils/MakeMaker/*.pm
     %{perl_root}/%{version}/ExtUtils/typemap
     %{perl_root}/%{version}/ExtUtils/xsubpp
%dir %{perl_root}/%{version}/File
     %{perl_root}/%{version}/File/*.pm
%dir %{perl_root}/%{version}/File/Spec
     %{perl_root}/%{version}/File/Spec/*.pm
%dir %{perl_root}/%{version}/Filter
     %{perl_root}/%{version}/Filter/*.pm
%dir %{perl_root}/%{version}/Getopt
     %{perl_root}/%{version}/Getopt/*.pm
%dir %{perl_root}/%{version}/Hash
     %{perl_root}/%{version}/Hash/*.pm
%dir %{perl_root}/%{version}/I18N
     %{perl_root}/%{version}/I18N/*.pm
%dir %{perl_root}/%{version}/I18N/LangTags
     %{perl_root}/%{version}/I18N/LangTags/*.pm
%dir %{perl_root}/%{version}/IO
%dir %{perl_root}/%{version}/IO/Socket
     %{perl_root}/%{version}/IO/Socket/*.pm
     %{perl_root}/%{version}/IPC
     %{perl_root}/%{version}/List
%dir %{perl_root}/%{version}/Locale
     %{perl_root}/%{version}/Locale/*.pm
%dir %{perl_root}/%{version}/Locale/Maketext
     %{perl_root}/%{version}/Locale/Maketext/*.pm
%dir %{perl_root}/%{version}/Math
     %{perl_root}/%{version}/Math/*.pm
     %{perl_root}/%{version}/Math/BigFloat
     %{perl_root}/%{version}/Math/BigInt
%dir %{perl_root}/%{version}/Memoize
     %{perl_root}/%{version}/Memoize/*.pm
%dir %{perl_root}/%{version}/Net
     %{perl_root}/%{version}/Net/*.pm
     %{perl_root}/%{version}/Net/Config.eg
%dir %{perl_root}/%{version}/Net/FTP
     %{perl_root}/%{version}/Net/FTP/*.pm
     %{perl_root}/%{version}/Net/Hostname.eg
%dir %{perl_root}/%{version}/Net/Ping
%dir %{perl_root}/%{version}/PerlIO
%dir %{perl_root}/%{version}/PerlIO/via
     %{perl_root}/%{version}/PerlIO/via/*.pm
%dir %{perl_root}/%{version}/Pod
     %{perl_root}/%{version}/Pod/*.pm
%dir %{perl_root}/%{version}/Pod/Perldoc
     %{perl_root}/%{version}/Pod/Perldoc/*.pm
%dir %{perl_root}/%{version}/Pod/Text
     %{perl_root}/%{version}/Pod/Text/*.pm
%dir %{perl_root}/%{version}/Scalar
     %{perl_root}/%{version}/Scalar/*.pm
%dir %{perl_root}/%{version}/Search
     %{perl_root}/%{version}/Search/*.pm
%dir %{perl_root}/%{version}/Term
     %{perl_root}/%{version}/Term/*.pm
%dir %{perl_root}/%{version}/Test
     %{perl_root}/%{version}/Test/*.pm
%dir %{perl_root}/%{version}/Test/Harness
     %{perl_root}/%{version}/Test/Harness/*.pm
%dir %{perl_root}/%{version}/Text
     %{perl_root}/%{version}/Text/*.pm
     %{perl_root}/%{version}/Thread
     %{perl_root}/%{version}/Tie
     %{perl_root}/%{version}/Time
%dir %{perl_root}/%{version}/Unicode
     %{perl_root}/%{version}/Unicode/*.pm
%dir %{perl_root}/%{version}/User
     %{perl_root}/%{version}/User/*.pm
     %{perl_root}/%{version}/auto
%dir %{perl_root}/%{version}/unicore
     %{perl_root}/%{version}/unicore/*.pl
     %{perl_root}/%{version}/unicore/To
     %{perl_root}/%{version}/unicore/lib
%dir %{perl_root}/%{version}/warnings
     %{perl_root}/%{version}/warnings/register.pm
%dir %{perl_root}/site_perl
%dir %{perl_root}/site_perl/%{version}
%dir %{perl_root}/site_perl/%{version}/i586-linux
%if %threading
%dir %{perl_root}/site_perl/%{version}/i586-linux-thread-multi
%endif
     %{_mandir}/man1/*
     %{_mandir}/man3/*


%files doc
%defattr(-,root,root)
     %{_bindir}/perldoc
     %{perl_root}/%{version}/Attribute/Handlers
     %{perl_root}/%{version}/CGI/eg
     %{perl_root}/%{version}/Encode/Changes.e2x
     %{perl_root}/%{version}/Encode/PerlIO.pod
     %{perl_root}/%{version}/Encode/README.e2x
     %{perl_root}/%{version}/Encode/Supported.pod
     %{perl_root}/%{version}/ExtUtils/Changes
     %{perl_root}/%{version}/ExtUtils/META.yml
     %{perl_root}/%{version}/ExtUtils/MakeMaker/*.pod
     %{perl_root}/%{version}/ExtUtils/NOTES
     %{perl_root}/%{version}/ExtUtils/PATCHING
     %{perl_root}/%{version}/ExtUtils/README
     %{perl_root}/%{version}/Filter/Simple
     %{perl_root}/%{version}/Getopt/Long
     %{perl_root}/%{version}/I18N/LangTags/ChangeLog
     %{perl_root}/%{version}/I18N/LangTags/README
     %{perl_root}/%{version}/Locale/*.pod
     %{perl_root}/%{version}/Locale/Codes
     %{perl_root}/%{version}/Locale/Maketext/*.pod
     %{perl_root}/%{version}/Locale/Maketext/ChangeLog
     %{perl_root}/%{version}/Locale/Maketext/README
     %{perl_root}/%{version}/Memoize/README
     %{perl_root}/%{version}/Memoize/TODO
     %{perl_root}/%{version}/NEXT
     %{perl_root}/%{version}/Net/ChangeLog.libnet
     %{perl_root}/%{version}/Net/Ping/Changes
     %{perl_root}/%{version}/Net/README.libnet
     %{perl_root}/%{version}/Net/demos
     %{perl_root}/%{version}/Net/libnetFAQ.pod
     %{perl_root}/%{version}/Switch
     %{perl_root}/%{version}/Term/ANSIColor
     %{perl_root}/%{version}/Test/Harness/Changes
     %{perl_root}/%{version}/Test/Simple
     %{perl_root}/%{version}/Test/Tutorial.pod
     %{perl_root}/%{version}/Text/Balanced
     %{perl_root}/%{version}/Text/TabsWrap
     %{perl_root}/%{version}/Unicode/Collate
     %{perl_root}/%{version}/Unicode/README
     %{perl_root}/%{version}/Win32.pod
     %{perl_root}/%{version}/pod
     %{perl_root}/%{version}/unicore/*.txt
     %{perl_root}/%{version}/unicore/Properties
     %{perl_root}/%{version}/unicore/README.perl
     %{perl_root}/%{version}/unicore/mktables
     %{perl_root}/%{version}/unicore/version

%files devel
%defattr(-,root,root)
     %{_bindir}/c2ph
     %{_bindir}/dprofpp
     %{_bindir}/h2ph
     %{_bindir}/h2xs
     %{_bindir}/perlcc
     %{_bindir}/pl2pm
     %{_bindir}/pstruct
     %{_bindir}/podchecker
     %{_bindir}/podselect
     %{perl_root}/%{version}/Encode/encode.h


%changelog
* Fri Feb  4 2005 Erlend Midttun <erlendbm at trustix dot org> 5.8.3-5tr
- Added patch against CAN-2005-0155 and CAN-2005-0156

* Wed Sep 29 2004 Oystein Viggen <oysteivi at trustix dot com>
- Patch tempfile issue 

* Thu Jan 22 2004 Erlend Midttun <erlendbm at trustix dot org> 5.8.3-1tr
- New upstream.

* Wed Dec 17 2003 Gerald Dachs <gda at trustix dot org> 5.8.0-16tr
- rebuild against libgdbm.so.3
- patched again to work with db4-4.1.25 (patch5)
- ndbm support was in %files section but not in config
- fixed typo: perltreads => perlthreads

* Wed Nov 26 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-15tr
- Big rebuild.

* Fri Oct 31 2003 Chr. Toldnes <christht at trustix dot org> 5.8.0-14tr
- backport

* Sun Sep 28 2003 Chr. Toldnes <christht at tawie dot org> 5.8.0-13tsl
- port to tawie

* Thu Jul 31 2003 Goetz Bock <bock at trustix dot org> 5.8.0-12bg
- fixed CGI.pm XSS bug (patch4)
- added patch for install suid root perl /wo beeing root (patch3)

* Tue Jul 29 2003 Goetz Bock <bock at trustix dot org> 5.8.0-11bg
- added patches (patch0, patch1) to make MakeMaker work sane again
- fixed Groups for -doc and -devel

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-10tr
- Added %defattr.

* Thu Jun 19 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-9tr
- Fixed group.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-8tr
- Big rebuild.

* Sat Jun  7 2003 Gerald Dachs <gda at trustix dot org> 5.8.0-7gd
- fixed default man dir in MakeMaker

* Sat Jun  7 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-6em
- Fixed file conflict /usr/lib/perl5/5.8.0/Memoize/README

* Wed Apr 30 2003 Christian H. Toldnes <christht at trustix dot dom> 5.8.0-5ct
- mv man3/threads.3 man3/perlthreads.3

* Wed Apr 30 2003 Christian H. Toldnes <christht at trustix dot dom> 5.8.0-4ct
- Merged perl and perl-base
- Cleanup

* Tue Mar 25 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-3em
- Now as i586

* Tue Mar 25 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-2em
- Added some more files.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-1em
- Rebuilt on glibc 2.3.2.

* Mon Mar  3 2003 Goetz Bock <bock at trustix dot org> 5.8.0-0bg
- new upstream: 5.8.0
- rebuild with db4-4.1.25
- disabled DB_File (-Ui_db) as perl does not like db4-4.1.25
- splitted perl into 4 rpms: perl, perl-base, perl-devel, perl-doc

* Fri Sep 13 2002 Christian H. Toldnes <christht at trustix dot com> 5.6.1-13ct
- Patched to build with gcc-3.x (Patch0)

* Thu Jul 11 2002 Nico Erfurth <ne@perlgolf.de> 5.6.1-12ne
- Fixed LFS-check

* Fri Jun 28 2002 Nico Erfurth <ne@perlgolf.de> 5.6.1-11ne
- Using LargeFileSupport-Macro
- Added gdbm-devel to Build-Requires

* Mon May 30 2002 Nico Erfurth <masta at trustix dot org>
- Checks now for glibc version, if above 2.1 then 
  we use LARGEFILE else we refuse it
- Upgraded Digest::MD5 to version 2.20

* Mon May 27 2002 Nico Erfurth <masta at trustix dot org>
- Fixed the wrong location for man-pages
- changed the suffix from tr to ne

* Mon Feb 11 2002 Nico Erfurth <masta at trustix dot org>
- Fixed MD5-Compilation and installation

* Fri Jan 11 2002 Nico Erfurth <masta at trustix dot org>
- updated MD5 to 2.02

* Mon Oct 29 2001 Nico Erfurth <masta@kema.at>
- version 5.6.1
- updated version-format to MAJOR.MINOR.PATCHLEVEL
- added make test before make install

* Tue Jul  3 2001 Oystein Viggen <oysteivi at trustix dot com>
- define _noVersionedDependencies

* Mon Aug 14 2000 Oystein Viggen <oysteivi at trustix dot com>
- patch to use syslog instead of /bin/mail for reporting errors

* Tue Feb  8 2000 Tore Olsen <toreo at trustix dot com>
- moved /usr/man to /usr/share/man for FHS compliance

* Fri Jan 14 2000 Jeff Johnson <jbj@redhat.com>
- add provides for perl modules (from kestes@staff.mail.com).

* Mon Oct 04 1999 Cristian Gafton <gafton@redhat.com>
- fix the %install so that the MD5 module gets actually installed correctly

* Mon Aug 30 1999 Cristian Gafton <gafton@redhat.com>
- make sure the package builds even when we don't have perl installed on the
  system

* Fri Aug 06 1999 Cristian Gafton <gafton@redhat.com>
- merged with perl-MD5
- get rid of the annoying $RPM_BUILD_ROOT paths in the installed tree

* Mon Jul 26 1999 Cristian Gafton <gafton@redhat.com>
- do not link anymore against the system db library (and make each module
  link against it separately, so that we can have Berkeley db1 and db2 mixed
  up)

* Wed Jun 16 1999 Cristian Gafton <gafton@redhat.com>
- use wildcards for files in /usr/bin and /usr/man

* Tue Apr 06 1999 Cristian Gafton <gafton@redhat.com>
- version 5.00503
- make the default man3 install dir be release independent
- try to link against db1 to preserve compatibility with older databases;
  abandoned idea because perl is too broken to allow such an easy change
  (hardcoded names *everywhere* !!!)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- guilty of the inlined Makefile in the spec file
- adapted for the arm build

* Wed Sep 09 1998 Preston Brown <pbrown@redhat.com>
- added newer CGI.pm to the build
- changed the version naming scheme around to work with RPM

* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- attempt to generate *.ph files reproducibly

* Mon Jun 15 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.004_04-m4 (pre-5.005 maintenance release)

* Tue Jun 12 1998 Christopher McCrory <chrismcc@netus.com
- need stdarg.h from gcc shadow to fix "use Sys::Syslog" (problem #635)

* Fri May 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to correct the .ph constructs unless defined (foo) to read
  unless(defined(foo))

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Mar 10 1998 Cristian Gafton <gafton@redhat.com>
- fixed strftime problem

* Sun Mar 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to fix a security race
- do not use setres[ug]id - those are not implemented on 2.0.3x kernels

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 5.004_04 - 5.004_01 had some nasty memory leaks.
- fixed the spec file to be version-independent

* Fri Dec 05 1997 Erik Troan <ewt@redhat.com>
- Config.pm wasn't right do to the builtrooting

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- fixed arch-specfic part of spec file

* Sun Oct 19 1997 Erik Troan <ewt@redhat.com>
- updated to perl 5.004_01
- users a build root

* Thu Jun 12 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- Incorporated security patch from Chip Salzenberg <salzench@nielsenmedia.com>

* Fri Feb 07 1997 Erik Troan <ewt@redhat.com>
- Use -Darchname=i386-linux 
- Require csh (for glob)
- Use RPM_ARCH during configuration and installation for arch independence
